;----------------------------------------------------------------------	;
;									;
;	Find gba program v1.0						;
;	for TI-83+ (every shells)					;
;	Martin Bousquet (martin.bousquet@hotmail.fr)			;
;	adapted from mario Load_level routine by Sam Heald		;
;	December 2006							;
;									;
;----------------------------------------------------------------------	;

; v1.0

.nolist
;;; variables

PROG_PTR		=$9830
P_TEMP			=$982e
GBA_VAR			=$8508

screen_width		=GBA_VAR		;1 octet  (12)
screen_height		=GBA_VAR+1		;1 octet  (8)
zero_point		=GBA_VAR+2		;2 octets

new_sprite		=GBA_VAR+4		;2 octets
tile_zero		=GBA_VAR+6		;1 octet
n_tiles2		=GBA_VAR+7		;1 octet

n_sprite		=GBA_VAR+8		;1 octet
sprite_table		=GBA_VAR+9		;2 octets
sprite_max		=GBA_VAR+11		;1 octet
l_sprite		=GBA_VAR+12		;2 octets

tiles_addr		=GBA_VAR+14		;2 octets
map_addr		=GBA_VAR+16		;2 octets
map_width		=GBA_VAR+18		;2 octets
map_height		=GBA_VAR+20		;2 octets
scroll_y		=GBA_VAR+22		;2 octets
scroll_x		=GBA_VAR+24		;2 octets

mask_y			=GBA_VAR+26		;1 octet
mask_x			=GBA_VAR+27		;1 octet
mask_x2			=GBA_VAR+28		;1 octet
temp			=GBA_VAR+29		;1 octet
temp2			=GBA_VAR+30		;1 octet
temp3			=GBA_VAR+31		;1 octet


;;; routines

gba_initmap		=GBA_VAR+32
gba_hl_plus_dexbc	=GBA_VAR+35
gba_restoremap		=GBA_VAR+38
gba_scroll_right	=GBA_VAR+41
gba_scroll_left		=GBA_VAR+44
gba_scroll_up		=GBA_VAR+47
gba_scroll_down		=GBA_VAR+50
gba_collision		=GBA_VAR+53
gba_findsprite		=GBA_VAR+56
gba_initsprite		=GBA_VAR+59
gba_drawsprite		=GBA_VAR+62

gba_drawinverted	=GBA_VAR+80

	; GBA_VAR+86
.list

Find_gba:
	ld hl,GBA_VAR
	ld de,GBA_VAR+1
	ld bc,86-1
	ld (hl),0
	ldir
	ld hl,(PROG_PTR)
TGBA_boucle:
	ld de,(P_Temp)
	inc de
	or a
	sbc hl,de
	ret c
	add hl,de
	ld a,(hl)
	dec hl \ dec hl \ dec hl
	ld e,(hl)
	dec hl
	ld d,(hl)
	dec hl \ dec hl
	ld b,(hl)
	dec hl
	and %00011111
	sub 6
	jr nz,TGBA_varsuivante
	ld ix,Gba_nom
TGBA_verifnom:
	ld a,(ix)
	cp (hl)
	jr nz,TGBA_varsuivante
	inc ix
	dec hl
	djnz TGBA_verifnom
	ex de,hl
	ld de,25
	add hl,de

	ld (TGBA_repere+1),hl
	ld de,GBA_VAR+32
	ld b,18
TGBA_boucle3:
	push bc
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	push hl
TGBA_repere:
	ld hl,$0000
	add hl,bc
	ld b,h
	ld c,l
	pop hl
	ex de,hl
	ld (hl),$c3		; jp
	inc hl
	ld (hl),c
	inc hl
	ld (hl),b
	inc hl
	ex de,hl
	pop bc
	djnz TGBA_boucle3
	ld a,12
	ld (screen_width),a
	ld a,8
	ld (screen_height),a
	or a			; nc
	ret

TGBA_varsuivante:
	dec hl
	djnz TGBA_varsuivante
	jr TGBA_boucle


Gba_nom:
.db "#GBA"